SystemOrganization addCategory: #'528Project'!

Morph subclass: #GameBoard
	instanceVariableNames: 'boardSize windowSize board lineWidth'
	classVariableNames: ''
	poolDictionaries: ''
	category: '528Project'!

!GameBoard class methodsFor: 'as yet unclassified' stamp: 'HEnrySolberg 7/10/2014 03:54'!
boardSize: aBoardSizeInt windowSize: aWindowSizeInt
	^self new boardSize: aBoardSizeInt windowSize: aWindowSizeInt.! !

!GameBoard methodsFor: 'as yet unclassified' stamp: 'HEnrySolberg 7/10/2014 05:21'!
at: anX at: aY addGameObject: aGameObject
	(board at: anX at: aY) setOccupant: aGameObject.
	aGameObject x: anX; y: aY.
	aGameObject position: (self positionOfX: anX Y: aY).
	self addMorph: aGameObject.! !

!GameBoard methodsFor: 'as yet unclassified' stamp: 'HEnrySolberg 7/10/2014 04:16'!
boardSize: aBoardSizeInt windowSize: aWindowSizeInt

	self initialize.

	boardSize := aBoardSizeInt.
	windowSize := aWindowSizeInt.
	lineWidth := 2.
	board := Matrix new: aBoardSizeInt.
	
	self buildGrid.
	! !

!GameBoard methodsFor: 'as yet unclassified' stamp: 'HEnrySolberg 7/10/2014 04:23'!
buildGrid

	|spacing newBox|
	spacing := windowSize/boardSize.

	1 to: boardSize do:
	[ 
		:i |
		1 to: boardSize do:
		[ 
			:j |
			newBox := GameBox new.
			newBox width: spacing.
			newBox height: spacing.
			newBox borderStyle: (PartialBorder width: lineWidth hasTop: true hasRight: true hasBottom: true hasLeft: true).
			newBox position: ((i-1)*spacing)@((j-1)*spacing).
			board at: i at: j put: newBox.
			newBox x: i.
			newBox y: j.
			self addMorph: newBox.
		]
	 ]! !

!GameBoard methodsFor: 'as yet unclassified' stamp: 'HEnrySolberg 7/10/2014 05:26'!
fromX: fromX fromY: fromY toX: toX toY: toY
	|mover|
	mover := (board at: fromX at: fromY) occupant.
	mover x: toX; y: toY.
	mover position: (self positionOfX: toX Y: toY).
	(board at: toX at: toY) setOccupant: mover.
	(board at: fromX at: fromY) setOccupant: nil.! !

!GameBoard methodsFor: 'as yet unclassified' stamp: 'HEnrySolberg 7/10/2014 06:53'!
moveGameObjectDown:  aGameObject
	aGameObject moveDownOnBoard: self.! !

!GameBoard methodsFor: 'as yet unclassified' stamp: 'HEnrySolberg 7/10/2014 06:44'!
moveGameObjectLeft:  aGameObject
	aGameObject moveLeftOnBoard: self.! !

!GameBoard methodsFor: 'as yet unclassified' stamp: 'HEnrySolberg 7/10/2014 06:45'!
moveGameObjectRight:  aGameObject
	aGameObject moveRightOnBoard: self.! !

!GameBoard methodsFor: 'as yet unclassified' stamp: 'HEnrySolberg 7/10/2014 06:45'!
moveGameObjectUp:  aGameObject
	aGameObject moveUpOnBoard: self.! !

!GameBoard methodsFor: 'as yet unclassified' stamp: 'HEnrySolberg 7/10/2014 04:37'!
positionOfX: anX Y: aY
	^(board at: anX at: aY) position.! !

Morph subclass: #GameObject
	instanceVariableNames: 'x y'
	classVariableNames: ''
	poolDictionaries: ''
	category: '528Project'!

!GameObject methodsFor: 'as yet unclassified' stamp: 'HEnrySolberg 7/10/2014 05:50'!
moveDownOnBoard: aBoard
	self moveOnBoard: aBoard toX: x toY: y + 1.! !

!GameObject methodsFor: 'as yet unclassified' stamp: 'HEnrySolberg 7/10/2014 05:50'!
moveLeftOnBoard: aBoard
	self moveOnBoard: aBoard toX: x - 1 toY: y.! !

!GameObject methodsFor: 'as yet unclassified' stamp: 'HEnrySolberg 7/10/2014 05:51'!
moveOnBoard: aBoard toX: toX toY: toY
	aBoard fromX: x fromY: y toX: toX toY: toY.
	x := toX.
	y := toY.! !

!GameObject methodsFor: 'as yet unclassified' stamp: 'HEnrySolberg 7/10/2014 05:17'!
moveRight
	! !

!GameObject methodsFor: 'as yet unclassified' stamp: 'HEnrySolberg 7/10/2014 05:48'!
moveRightOnBoard: aBoard
	self moveOnBoard: aBoard toX: x + 1 toY: y.
	! !

!GameObject methodsFor: 'as yet unclassified' stamp: 'HEnrySolberg 7/10/2014 05:50'!
moveUpOnBoard: aBoard
	self moveOnBoard: aBoard toX: x toY: y - 1.! !

!GameObject methodsFor: 'as yet unclassified' stamp: 'HEnrySolberg 7/10/2014 04:34'!
x: anX
	x := anX.! !

!GameObject methodsFor: 'as yet unclassified' stamp: 'HEnrySolberg 7/10/2014 04:34'!
y: aY
	y := aY.! !

BorderedMorph subclass: #GameBox
	instanceVariableNames: 'x y occupant northWall eastWall southWall westWall'
	classVariableNames: ''
	poolDictionaries: ''
	category: '528Project'!

!GameBox methodsFor: 'as yet unclassified' stamp: 'HEnrySolberg 7/10/2014 05:23'!
initialize
	super initialize.
	x := 0.
	y := 0.
	northWall := true.
	eastWall := true.
	southWall := true.
	westWall := true.
	occupant := nil.
	color := Color gray.! !

!GameBox methodsFor: 'as yet unclassified' stamp: 'HEnrySolberg 7/10/2014 05:23'!
occupant
	^occupant! !

!GameBox methodsFor: 'as yet unclassified' stamp: 'HEnrySolberg 7/10/2014 05:23'!
setOccupant: aGameObject.
	occupant := aGameObject.! !

!GameBox methodsFor: 'as yet unclassified' stamp: 'HEnrySolberg 7/10/2014 04:33'!
x: anX
	x := anX.! !

!GameBox methodsFor: 'as yet unclassified' stamp: 'HEnrySolberg 7/10/2014 04:24'!
y: aY
	y := aY.! !

SimpleBorder subclass: #PartialBorder
	instanceVariableNames: 'hasTop hasRight hasBottom hasLeft'
	classVariableNames: ''
	poolDictionaries: ''
	category: '528Project'!

!PartialBorder class methodsFor: 'as yet unclassified' stamp: 'HEnrySolberg 7/10/2014 01:22'!
width: width hasTop: aBool1 hasRight: aBool2 hasBottom: aBool3 hasLeft: aBool4
	^self new
		width: width;
		hasTop: aBool1 hasRight: aBool2 hasBottom: aBool3 hasLeft: aBool4.! !

!PartialBorder methodsFor: 'as yet unclassified' stamp: 'HEnrySolberg 7/10/2014 03:08'!
frameRectangle: aRectangle on: aCanvas

	hasTop ifTrue: [aCanvas 
		line: aRectangle topLeft + (self width / 2) ceiling
		to: aRectangle topRight + (self width / 2) ceiling
		width: self width 
		color: self color].
	hasRight ifTrue: [aCanvas 
		line: aRectangle topRight - (self width / 2) ceiling
		to: aRectangle bottomRight - (self width / 2) ceiling
		width: self width 
		color: self color].
	hasBottom ifTrue: [aCanvas 
		line: aRectangle bottomRight - (self width / 2) ceiling
		to: aRectangle bottomLeft - (self width / 2) ceiling
		width: self width 
		color: self color].
	hasLeft ifTrue: [aCanvas 
		line: aRectangle bottomLeft + (self width / 2) ceiling
		to: aRectangle topLeft + (self width / 2) ceiling
		width: self width 
		color: self color].! !

!PartialBorder methodsFor: 'as yet unclassified' stamp: 'HEnrySolberg 7/10/2014 01:12'!
hasTop: aBool1 hasRight: aBool2 hasBottom: aBool3 hasLeft: aBool4
	hasTop := aBool1.
	hasRight := aBool2.
	hasBottom := aBool3.
	hasLeft := aBool4.! !

!PartialBorder methodsFor: 'as yet unclassified' stamp: 'HEnrySolberg 7/10/2014 02:49'!
initialize
	super initialize.
	self width: 7 .
	self color: Color black .
	self hasTop: true hasRight: true hasBottom: true hasLeft: true! !

!PartialBorder methodsFor: 'as yet unclassified' stamp: 'HEnrySolberg 7/10/2014 01:26'!
style
	^#partial! !
